#pragma once
#include "simplefsm.hpp"
#include <guecs/ui.hpp>
#include "gui/status_ui.hpp"
#include "gui/loot_ui.hpp"
#include "gui/event_router.hpp"

namespace gui {
  enum class DNDState {
    START=100,
    LOOTING=101,
    LOOT_GRAB=102,
    INV_GRAB=103,
    END=104
  };

  class DNDLoot : public DeadSimpleFSM<DNDState, Event> {
    public:
      std::optional<guecs::Entity> $grab_source = std::nullopt;
      StatusUI& $status_ui;
      LootUI& $loot_ui;
      sf::RenderWindow& $window;
      routing::Router& $router;

      DNDLoot(StatusUI& status_ui,
          LootUI& loot_ui, sf::RenderWindow& window,
          routing::Router& router);

      bool event(Event ev, std::any data={});

      void START(Event ev);
      void LOOTING(Event ev, std::any data);
      void LOOT_GRAB(Event ev, std::any data);
      void INV_GRAB(Event ev, std::any data);
      void END(Event ev);
      void mouse_action(bool hover);
      sf::Vector2f mouse_position();
  };
}
